import pygame, random
import mmRope, mmPlayer

img_bg = None
img_player = None
img_shake = range(13)

screen = None
SCREEN_WIDTH = 800
SCREEN_HEIGHT = 600

def load_image(filename, colorkey = False):
    image = pygame.image.load(filename)
    image.convert()
    if colorkey:
        image.set_colorkey((255,255,0), pygame.RLEACCEL)
    return image

def init_pygame():
    global screen
    pygame.init()
    pygame.font.init()
    screen = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT))
def load_files():
    global img_bg, img_shake, img_player
    img_bg = load_image("data/backgroung.jpg")
    img_player = load_image("data/mime.png")
    for i in range(13):
        img_shake[i] = load_image("data/shake/shake" + str(i) + ".png")


def main():
    init_pygame()
    load_files()

    player = mmPlayer.Player(img_player, (400,300))
    tight_rope = mmRope.TightRope(SCREEN_WIDTH, SCREEN_HEIGHT, img_shake)

    screen.blit(img_bg, (0,0))

    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_SPACE:
                    #tight_rope.start_shake()
                    pass
                if event.key == pygame.K_ESCAPE:
                    return

        #pre draw
        screen.blit(img_bg, (0,430-50), (0,430-50,800,100))
        screen.blit(img_bg, player.predraw(), player.predraw())
        
        
        #update
        s = player.update(pygame.mouse.get_pos()[0], tight_rope.srange)
        if s:
            tight_rope.start_shake()
        if player.rect.y > 430:
            tight_rope.set_point(player.rect.x,player.rect.y)
        else:
            tight_rope.set_point(0,430)
        tight_rope.update()
        #tight_rope.set_point(400,300)
        pygame.mouse.set_pos(SCREEN_WIDTH/2, SCREEN_HEIGHT/2)
        #draw
        tight_rope.draw()
        player.show()        
        pygame.display.flip()

        
        


