import pygame, random, math

class Player:
    def __init__(self, img, start_pos):
        self.image = img
        self.rect = self.image.get_rect()
        self.rect.x = start_pos[0]
        self.rect.y = start_pos[1]
        self.rate = 0.8
        self.last_time = pygame.time.get_ticks()
        self.tilt = 0.0
        self.max_tilt = 0.5
        self.jump_vel = 0
        self.vert = 0.0
        self.jumping = True
        self.rimage = self.image
        
    def update(self, mx, shake):
        delta = float(pygame.time.get_ticks() - self.last_time)
        keystate = pygame.key.get_pressed()
        
        
        degree = mx-400
        if degree > 64:
            degree = 64
        if degree < -64:
            degree = -64
            
        
            
        degree = 1.0 * (float(degree)/64.0)
        self.tilt += degree*self.rate
        if self.tilt > self.max_tilt: self.tilt = self.max_tilt
        if self.tilt < -self.max_tilt: self.tilt = -self.max_tilt
             
        self.rect.x += self.tilt*delta
        
        #jumping
        
        rshake = False
        if keystate[pygame.K_SPACE] and not self.jumping:
            self.jump()
            rshake = True
        
        if self.jumping:      
            self.vert -= 0.005 * delta
            self.rect.y -= self.vert * delta
            
        if self.rect.y > 430+20:
            self.rect.y = 430+20
            if self.vert < 0:
                self.jumping = False
        
        
        self.last_time = pygame.time.get_ticks()
        
        return rshake
        
    def jump(self):
        self.vert = 1.5   
        self.jumping = True     
        
    def predraw(self):
        r = self.rimage.get_rect()
        r.x = self.rect.x
        r.y = self.rect.y
        t = 0
        if(self.tilt < 0):
            t = self.tilt * 70
        return (r.x-(r.w/2), r.y-r.h, r.w, r.h+20)
            
    def show(self):
        self.rimage = pygame.transform.rotozoom(self.image, -self.tilt * 45, 1)
        t = 0
        if(self.tilt < 0):
            t = self.tilt * 70
            
        pygame.display.get_surface().blit(self.rimage, (self.rect.x-(self.rect.w/2) + t, self.rect.y-self.rect.h - abs(self.tilt)*30))
    
    
    
    
    
    
    
    
    
    
    
    
